WARMON:	EQU	0F86CH	; "Горячий Монитор"
SCREEN:	EQU	076D0H	; Обычно - 36D0/76D0
;;;;;;;;;;;;;;;;;;;;;;;;;
PUTHEX: EQU     0F815H
PUTEXT: EQU     0F818H
GETMEM: EQU     0F830H
WARMON: EQU     0F86CH
;;;;;;;;;;;;;;;;;;;;;;;;;
STOPTR: EQU     07629H  ; Адрес останова (7623 или второй параметр)
STOPIC: EQU     07625H  ; Сохранённый код инструкции
DIRDE:  EQU     07629H  ; Второй параметр директивы (передаётся в DE)
DIRBC:  EQU     0762BH  ; Третий параметр директивы (передаётся в BC)
;;;;;;;;;;;;;;;;;;;;;;;;;

        ORG     00000H
;;;;;;;;;;;;;;;;;;;;;;;;;
        LHLD    STOPTR  ; Читаем адрес "порчи" (слово в 7623 или 7629)
        MOV     A,H     ; и проверяем,
        ORA     L       ; был ли второй параметр у директивы G?
        JZ      BEGIN   ; Если указатель - "нулевой", значит отсутствует.
        LDA     STOPIC  ; Иначе, читаем код инструкции
        MOV     M,A     ; и "снимаем порчу" у ячейки, которая "прихворала".
BEGIN:  XCHG            ; Заносим второй параметр в DE.
        DCX     SP      ; Корректируем указатель стека
        DCX     SP      ; для благополучного возврата в Монитор.
	LHLD	DIRDE	; Читаем второй параметр директивы
	XCHG		; Переносим его как формат экрана в DE
	LHLD	DIRBC	; Читаем третий параметр директивы
	MOV	B,H	; Переносим всё
	MOV	C,L	; в регистры BC
	DCR	H	; Нельзя указывать буфер ниже адреса 0100
	JP	START	; Производим проверку
	LXI	B,SCREEN; Обычно - 36D0/76D0
	;;;;;;;;;;;;;;;;;
START:	DCR	D	; Корректируем высоту кадра
	JP	START1	; Если он меньше 1
	MVI	D,029H	; Индекс последней строки в кадре (0..29 - 30 строк)
START1:	DCR	E	; Корректируем ширину кадра
	JP	START2	; Если он меньше 1
	MVI	E,077H	; Индекс последнего знакоместа строки (0..77 - 78 букв)
START2:	JMP	FORMAD	; Теперь всё готово к установке и выходим
;;;;;;;;;;;;;;;;;;;;;;;;;
	LXI	SP,4156H; Здесь немного
        MOV     C,H	; различной "магии",
        MOV     C,C	; иначе - не заработает!
;;;;;;;;;;;;;;;;;;;;;;;;;
FORMAD:	MOV	A,D	; Двоично-десятичный вариант подпрограммы
	CALL	FROM10	; Преобразовываем высоту
	MOV	D,A	; Запоминаем
	MOV	A,E	; Теперь
	CALL	FROM10	; преобразовываем ширину
	MOV	E,A	; Запоминаем
FORMAT:	PUSH	D	; Запоминаем данные о формате
	;;;;;;;;;;;;;;;;;
	LXI	H,03FFFH; Предустановка счётчика знакомест в кадре
FORM@Y:	MOV	A,E	; Счётчик символов в строке
FORM@X:	INX	H	; Производим счёт всех байтов
	DCR	A	; Считаем каждый символ в строке
	JP	FORM@X	; И добавляем его в общую сумму
	DCR	D	; Считаем каждую строку в кадре
	JP	FORM@Y	; И добавляем её в общую сумму
	;;;;;;;;;;;;;;;;;
	POP	D	; Восстанавливаем формат
	PUSH	H	; Запоминаем объём буфера
;;;;;;;;;;;;;;;;;;;;;;;;;
SET@75:	LXI	H,0C001H; Адрес ВГ75 для слова управления
	MVI	M,000H	; Команда установки
	DCX	H	; Адрес ВГ75 для слов данных
	MOV	M,E	; Ширина экрана - последнее знакоместо в строке
	MOV	M,D	; Высота экрана - последний знакоряд в кадре
	MVI	M,9*16+9; Позиция курсора над символом и высота одного символа
	MVI	M,093H	; Прочие режимы (мерцание/форма курсора и толщина КСИ)
	INX	H	; Адрес ВГ75 для управления
	MVI	M,027H	; Команда запуска отображения и режим ПДП
	XTHL		; Временно запоминаем адрес статуса ВГ75 восстанавливая объём
	XCHG		; Информация о формате больше не требуется: DE = Объём буфера
	;;;;;;;;;;;;;;;;;
SET@57:	LXI	H,0E008H; Адрес ВТ57 для слова управления
	MVI	M,080H	; Готовимся его перепрограммировать
	MVI	L,004H	; Канал #2 обслуживает ВГ75
	MOV	M,C	; Младшие разряды адреса буфера экрана
	MOV	M,B	; Старшие разряды адреса буфера экрана
	INX	H	; Переходим к объёму буфера
	MOV	M,E	; Младдший байт размера буфера
	MOV	M,D	; Старший байт размера буфера и биты режима
	MVI	L,008	; Адрес ВТ57 для слова управления
	POP	B	; Возвращаемся к ВГ75 за статусом
	LDAX	B	; Сбрасываем все устаревшие флаги
WAIT:	LDAX	B	; Ожидаем очередные новые флаги
	ANI	020H	; Нас интересует флаг бита #5: Конец кадра и прерывание
	JZ	WAIT	; Дожидаемся его установки в "1"
	MVI	M,0A4H	; Запускаем ПДП синхронно с новым кадром
	RET		;
;;;;;;;;;;;;;;;;;;;;;;;;;
FROM10:	PUSH	PSW	; Запоминаем байт целиком
	RRC		; Теперь нам
	RRC		; необходимо
	RRC		; добраться до
	RRC		; старшей тетрады
	ANI	00FH	; Маскируем биты тетрады
	MOV	L,A	; и запоминаем "десятки"
	ADD	A	; Теперь умножаем
	ADD	A	; последовательными
	ADD	L	; действиями на 10,
	ADD	A	; чтобы двоично-десятичным байт
	MOV	L,A	; перевести в двоичное представление в L
	POP	PSW	; Извлекаем из стека значение обратно
	ANI	00FH	; Маскируем
	ADD	L	; И складываем десятки с единицами
	RET		;
;;;;;;;;;;;;;;;;;;;;;;;;;